]> git.ipfire.org Git - thirdparty/git.git/blob - git-submodule.sh
rebase -i: clarify in-editor documentation of "exec"
[thirdparty/git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodules.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-parse-remote
18 require_work_tree
19
20 command=
21 branch=
22 force=
23 reference=
24 cached=
25 recursive=
26 init=
27 files=
28 nofetch=
29 update=
30 prefix=
31
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
34 {
35 remote=$(get_default_remote)
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
38 url="$1"
39 remoteurl=${remoteurl%/}
40 sep=/
41 while test -n "$url"
42 do
43 case "$url" in
44 ../*)
45 url="${url#../}"
46 case "$remoteurl" in
47 */*)
48 remoteurl="${remoteurl%/*}"
49 ;;
50 *:*)
51 remoteurl="${remoteurl%:*}"
52 sep=:
53 ;;
54 *)
55 die "cannot strip one component off url '$remoteurl'"
56 ;;
57 esac
58 ;;
59 ./*)
60 url="${url#./}"
61 ;;
62 *)
63 break;;
64 esac
65 done
66 echo "$remoteurl$sep${url%/}"
67 }
68
69 #
70 # Get submodule info for registered submodules
71 # $@ = path to limit submodule list
72 #
73 module_list()
74 {
75 git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
76 }
77
78 #
79 # Map submodule path to submodule name
80 #
81 # $1 = path
82 #
83 module_name()
84 {
85 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
86 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
87 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
88 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
89 test -z "$name" &&
90 die "No submodule mapping found in .gitmodules for path '$path'"
91 echo "$name"
92 }
93
94 #
95 # Clone a submodule
96 #
97 # Prior to calling, cmd_update checks that a possibly existing
98 # path is not a git repository.
99 # Likewise, cmd_add checks that path does not exist at all,
100 # since it is the location of a new submodule.
101 #
102 module_clone()
103 {
104 path=$1
105 url=$2
106 reference="$3"
107
108 if test -n "$reference"
109 then
110 git-clone "$reference" -n "$url" "$path"
111 else
112 git-clone -n "$url" "$path"
113 fi ||
114 die "Clone of '$url' into submodule path '$path' failed"
115 }
116
117 #
118 # Add a new submodule to the working tree, .gitmodules and the index
119 #
120 # $@ = repo path
121 #
122 # optional branch is stored in global branch variable
123 #
124 cmd_add()
125 {
126 # parse $args after "submodule ... add".
127 while test $# -ne 0
128 do
129 case "$1" in
130 -b | --branch)
131 case "$2" in '') usage ;; esac
132 branch=$2
133 shift
134 ;;
135 -f | --force)
136 force=$1
137 ;;
138 -q|--quiet)
139 GIT_QUIET=1
140 ;;
141 --reference)
142 case "$2" in '') usage ;; esac
143 reference="--reference=$2"
144 shift
145 ;;
146 --reference=*)
147 reference="$1"
148 shift
149 ;;
150 --)
151 shift
152 break
153 ;;
154 -*)
155 usage
156 ;;
157 *)
158 break
159 ;;
160 esac
161 shift
162 done
163
164 repo=$1
165 path=$2
166
167 if test -z "$path"; then
168 path=$(echo "$repo" |
169 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
170 fi
171
172 if test -z "$repo" -o -z "$path"; then
173 usage
174 fi
175
176 # assure repo is absolute or relative to parent
177 case "$repo" in
178 ./*|../*)
179 # dereference source url relative to parent's url
180 realrepo=$(resolve_relative_url "$repo") || exit
181 ;;
182 *:*|/*)
183 # absolute url
184 realrepo=$repo
185 ;;
186 *)
187 die "repo URL: '$repo' must be absolute or begin with ./|../"
188 ;;
189 esac
190
191 # normalize path:
192 # multiple //; leading ./; /./; /../; trailing /
193 path=$(printf '%s/\n' "$path" |
194 sed -e '
195 s|//*|/|g
196 s|^\(\./\)*||
197 s|/\./|/|g
198 :start
199 s|\([^/]*\)/\.\./||
200 tstart
201 s|/*$||
202 ')
203 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
204 die "'$path' already exists in the index"
205
206 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
207 then
208 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
209 echo >&2 $path &&
210 echo >&2 "Use -f if you really want to add it."
211 exit 1
212 fi
213
214 # perhaps the path exists and is already a git repo, else clone it
215 if test -e "$path"
216 then
217 if test -d "$path"/.git -o -f "$path"/.git
218 then
219 echo "Adding existing repo at '$path' to the index"
220 else
221 die "'$path' already exists and is not a valid git repo"
222 fi
223
224 case "$repo" in
225 ./*|../*)
226 url=$(resolve_relative_url "$repo") || exit
227 ;;
228 *)
229 url="$repo"
230 ;;
231 esac
232 git config submodule."$path".url "$url"
233 else
234
235 module_clone "$path" "$realrepo" "$reference" || exit
236 (
237 clear_local_git_env
238 cd "$path" &&
239 # ash fails to wordsplit ${branch:+-b "$branch"...}
240 case "$branch" in
241 '') git checkout -f -q ;;
242 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
243 esac
244 ) || die "Unable to checkout submodule '$path'"
245 fi
246
247 git add $force "$path" ||
248 die "Failed to add submodule '$path'"
249
250 git config -f .gitmodules submodule."$path".path "$path" &&
251 git config -f .gitmodules submodule."$path".url "$repo" &&
252 git add --force .gitmodules ||
253 die "Failed to register submodule '$path'"
254 }
255
256 #
257 # Execute an arbitrary command sequence in each checked out
258 # submodule
259 #
260 # $@ = command to execute
261 #
262 cmd_foreach()
263 {
264 # parse $args after "submodule ... foreach".
265 while test $# -ne 0
266 do
267 case "$1" in
268 -q|--quiet)
269 GIT_QUIET=1
270 ;;
271 --recursive)
272 recursive=1
273 ;;
274 -*)
275 usage
276 ;;
277 *)
278 break
279 ;;
280 esac
281 shift
282 done
283
284 toplevel=$(pwd)
285
286 module_list |
287 while read mode sha1 stage path
288 do
289 if test -e "$path"/.git
290 then
291 say "Entering '$prefix$path'"
292 name=$(module_name "$path")
293 (
294 prefix="$prefix$path/"
295 clear_local_git_env
296 cd "$path" &&
297 eval "$@" &&
298 if test -n "$recursive"
299 then
300 cmd_foreach "--recursive" "$@"
301 fi
302 ) ||
303 die "Stopping at '$path'; script returned non-zero status."
304 fi
305 done
306 }
307
308 #
309 # Register submodules in .git/config
310 #
311 # $@ = requested paths (default to all)
312 #
313 cmd_init()
314 {
315 # parse $args after "submodule ... init".
316 while test $# -ne 0
317 do
318 case "$1" in
319 -q|--quiet)
320 GIT_QUIET=1
321 ;;
322 --)
323 shift
324 break
325 ;;
326 -*)
327 usage
328 ;;
329 *)
330 break
331 ;;
332 esac
333 shift
334 done
335
336 module_list "$@" |
337 while read mode sha1 stage path
338 do
339 # Skip already registered paths
340 name=$(module_name "$path") || exit
341 url=$(git config submodule."$name".url)
342 test -z "$url" || continue
343
344 url=$(git config -f .gitmodules submodule."$name".url)
345 test -z "$url" &&
346 die "No url found for submodule path '$path' in .gitmodules"
347
348 # Possibly a url relative to parent
349 case "$url" in
350 ./*|../*)
351 url=$(resolve_relative_url "$url") || exit
352 ;;
353 esac
354
355 git config submodule."$name".url "$url" ||
356 die "Failed to register url for submodule path '$path'"
357
358 upd="$(git config -f .gitmodules submodule."$name".update)"
359 test -z "$upd" ||
360 git config submodule."$name".update "$upd" ||
361 die "Failed to register update mode for submodule path '$path'"
362
363 say "Submodule '$name' ($url) registered for path '$path'"
364 done
365 }
366
367 #
368 # Update each submodule path to correct revision, using clone and checkout as needed
369 #
370 # $@ = requested paths (default to all)
371 #
372 cmd_update()
373 {
374 # parse $args after "submodule ... update".
375 orig_args="$@"
376 while test $# -ne 0
377 do
378 case "$1" in
379 -q|--quiet)
380 shift
381 GIT_QUIET=1
382 ;;
383 -i|--init)
384 init=1
385 shift
386 ;;
387 -N|--no-fetch)
388 shift
389 nofetch=1
390 ;;
391 -r|--rebase)
392 shift
393 update="rebase"
394 ;;
395 --reference)
396 case "$2" in '') usage ;; esac
397 reference="--reference=$2"
398 shift 2
399 ;;
400 --reference=*)
401 reference="$1"
402 shift
403 ;;
404 -m|--merge)
405 shift
406 update="merge"
407 ;;
408 --recursive)
409 shift
410 recursive=1
411 ;;
412 --)
413 shift
414 break
415 ;;
416 -*)
417 usage
418 ;;
419 *)
420 break
421 ;;
422 esac
423 done
424
425 if test -n "$init"
426 then
427 cmd_init "--" "$@" || return
428 fi
429
430 module_list "$@" |
431 while read mode sha1 stage path
432 do
433 name=$(module_name "$path") || exit
434 url=$(git config submodule."$name".url)
435 update_module=$(git config submodule."$name".update)
436 if test -z "$url"
437 then
438 # Only mention uninitialized submodules when its
439 # path have been specified
440 test "$#" != "0" &&
441 say "Submodule path '$path' not initialized" &&
442 say "Maybe you want to use 'update --init'?"
443 continue
444 fi
445
446 if ! test -d "$path"/.git -o -f "$path"/.git
447 then
448 module_clone "$path" "$url" "$reference"|| exit
449 subsha1=
450 else
451 subsha1=$(clear_local_git_env; cd "$path" &&
452 git rev-parse --verify HEAD) ||
453 die "Unable to find current revision in submodule path '$path'"
454 fi
455
456 if ! test -z "$update"
457 then
458 update_module=$update
459 fi
460
461 if test "$subsha1" != "$sha1"
462 then
463 force=
464 if test -z "$subsha1"
465 then
466 force="-f"
467 fi
468
469 if test -z "$nofetch"
470 then
471 (clear_local_git_env; cd "$path" &&
472 git-fetch) ||
473 die "Unable to fetch in submodule path '$path'"
474 fi
475
476 case "$update_module" in
477 rebase)
478 command="git rebase"
479 action="rebase"
480 msg="rebased onto"
481 ;;
482 merge)
483 command="git merge"
484 action="merge"
485 msg="merged in"
486 ;;
487 *)
488 command="git checkout $force -q"
489 action="checkout"
490 msg="checked out"
491 ;;
492 esac
493
494 (clear_local_git_env; cd "$path" && $command "$sha1") ||
495 die "Unable to $action '$sha1' in submodule path '$path'"
496 say "Submodule path '$path': $msg '$sha1'"
497 fi
498
499 if test -n "$recursive"
500 then
501 (clear_local_git_env; cd "$path" && cmd_update $orig_args) ||
502 die "Failed to recurse into submodule path '$path'"
503 fi
504 done
505 }
506
507 set_name_rev () {
508 revname=$( (
509 clear_local_git_env
510 cd "$1" && {
511 git describe "$2" 2>/dev/null ||
512 git describe --tags "$2" 2>/dev/null ||
513 git describe --contains "$2" 2>/dev/null ||
514 git describe --all --always "$2"
515 }
516 ) )
517 test -z "$revname" || revname=" ($revname)"
518 }
519 #
520 # Show commit summary for submodules in index or working tree
521 #
522 # If '--cached' is given, show summary between index and given commit,
523 # or between working tree and given commit
524 #
525 # $@ = [commit (default 'HEAD'),] requested paths (default all)
526 #
527 cmd_summary() {
528 summary_limit=-1
529 for_status=
530 diff_cmd=diff-index
531
532 # parse $args after "submodule ... summary".
533 while test $# -ne 0
534 do
535 case "$1" in
536 --cached)
537 cached="$1"
538 ;;
539 --files)
540 files="$1"
541 ;;
542 --for-status)
543 for_status="$1"
544 ;;
545 -n|--summary-limit)
546 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
547 then
548 :
549 else
550 usage
551 fi
552 shift
553 ;;
554 --)
555 shift
556 break
557 ;;
558 -*)
559 usage
560 ;;
561 *)
562 break
563 ;;
564 esac
565 shift
566 done
567
568 test $summary_limit = 0 && return
569
570 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
571 then
572 head=$rev
573 test $# = 0 || shift
574 elif test -z "$1" -o "$1" = "HEAD"
575 then
576 # before the first commit: compare with an empty tree
577 head=$(git hash-object -w -t tree --stdin </dev/null)
578 test -z "$1" || shift
579 else
580 head="HEAD"
581 fi
582
583 if [ -n "$files" ]
584 then
585 test -n "$cached" &&
586 die "--cached cannot be used with --files"
587 diff_cmd=diff-files
588 head=
589 fi
590
591 cd_to_toplevel
592 # Get modified modules cared by user
593 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
594 sane_egrep '^:([0-7]* )?160000' |
595 while read mod_src mod_dst sha1_src sha1_dst status name
596 do
597 # Always show modules deleted or type-changed (blob<->module)
598 test $status = D -o $status = T && echo "$name" && continue
599 # Also show added or modified modules which are checked out
600 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
601 echo "$name"
602 done
603 )
604
605 test -z "$modules" && return
606
607 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
608 sane_egrep '^:([0-7]* )?160000' |
609 cut -c2- |
610 while read mod_src mod_dst sha1_src sha1_dst status name
611 do
612 if test -z "$cached" &&
613 test $sha1_dst = 0000000000000000000000000000000000000000
614 then
615 case "$mod_dst" in
616 160000)
617 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
618 ;;
619 100644 | 100755 | 120000)
620 sha1_dst=$(git hash-object $name)
621 ;;
622 000000)
623 ;; # removed
624 *)
625 # unexpected type
626 echo >&2 "unexpected mode $mod_dst"
627 continue ;;
628 esac
629 fi
630 missing_src=
631 missing_dst=
632
633 test $mod_src = 160000 &&
634 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
635 missing_src=t
636
637 test $mod_dst = 160000 &&
638 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
639 missing_dst=t
640
641 total_commits=
642 case "$missing_src,$missing_dst" in
643 t,)
644 errmsg=" Warn: $name doesn't contain commit $sha1_src"
645 ;;
646 ,t)
647 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
648 ;;
649 t,t)
650 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
651 ;;
652 *)
653 errmsg=
654 total_commits=$(
655 if test $mod_src = 160000 -a $mod_dst = 160000
656 then
657 range="$sha1_src...$sha1_dst"
658 elif test $mod_src = 160000
659 then
660 range=$sha1_src
661 else
662 range=$sha1_dst
663 fi
664 GIT_DIR="$name/.git" \
665 git rev-list --first-parent $range -- | wc -l
666 )
667 total_commits=" ($(($total_commits + 0)))"
668 ;;
669 esac
670
671 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
672 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
673 if test $status = T
674 then
675 if test $mod_dst = 160000
676 then
677 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
678 else
679 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
680 fi
681 else
682 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
683 fi
684 if test -n "$errmsg"
685 then
686 # Don't give error msg for modification whose dst is not submodule
687 # i.e. deleted or changed to blob
688 test $mod_dst = 160000 && echo "$errmsg"
689 else
690 if test $mod_src = 160000 -a $mod_dst = 160000
691 then
692 limit=
693 test $summary_limit -gt 0 && limit="-$summary_limit"
694 GIT_DIR="$name/.git" \
695 git log $limit --pretty='format: %m %s' \
696 --first-parent $sha1_src...$sha1_dst
697 elif test $mod_dst = 160000
698 then
699 GIT_DIR="$name/.git" \
700 git log --pretty='format: > %s' -1 $sha1_dst
701 else
702 GIT_DIR="$name/.git" \
703 git log --pretty='format: < %s' -1 $sha1_src
704 fi
705 echo
706 fi
707 echo
708 done |
709 if test -n "$for_status"; then
710 if [ -n "$files" ]; then
711 echo "# Submodules changed but not updated:"
712 else
713 echo "# Submodule changes to be committed:"
714 fi
715 echo "#"
716 sed -e 's|^|# |' -e 's|^# $|#|'
717 else
718 cat
719 fi
720 }
721 #
722 # List all submodules, prefixed with:
723 # - submodule not initialized
724 # + different revision checked out
725 #
726 # If --cached was specified the revision in the index will be printed
727 # instead of the currently checked out revision.
728 #
729 # $@ = requested paths (default to all)
730 #
731 cmd_status()
732 {
733 # parse $args after "submodule ... status".
734 orig_args="$@"
735 while test $# -ne 0
736 do
737 case "$1" in
738 -q|--quiet)
739 GIT_QUIET=1
740 ;;
741 --cached)
742 cached=1
743 ;;
744 --recursive)
745 recursive=1
746 ;;
747 --)
748 shift
749 break
750 ;;
751 -*)
752 usage
753 ;;
754 *)
755 break
756 ;;
757 esac
758 shift
759 done
760
761 module_list "$@" |
762 while read mode sha1 stage path
763 do
764 name=$(module_name "$path") || exit
765 url=$(git config submodule."$name".url)
766 displaypath="$prefix$path"
767 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
768 then
769 say "-$sha1 $displaypath"
770 continue;
771 fi
772 set_name_rev "$path" "$sha1"
773 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
774 then
775 say " $sha1 $displaypath$revname"
776 else
777 if test -z "$cached"
778 then
779 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
780 set_name_rev "$path" "$sha1"
781 fi
782 say "+$sha1 $displaypath$revname"
783 fi
784
785 if test -n "$recursive"
786 then
787 (
788 prefix="$displaypath/"
789 clear_local_git_env
790 cd "$path" &&
791 cmd_status $orig_args
792 ) ||
793 die "Failed to recurse into submodule path '$path'"
794 fi
795 done
796 }
797 #
798 # Sync remote urls for submodules
799 # This makes the value for remote.$remote.url match the value
800 # specified in .gitmodules.
801 #
802 cmd_sync()
803 {
804 while test $# -ne 0
805 do
806 case "$1" in
807 -q|--quiet)
808 GIT_QUIET=1
809 shift
810 ;;
811 --)
812 shift
813 break
814 ;;
815 -*)
816 usage
817 ;;
818 *)
819 break
820 ;;
821 esac
822 done
823 cd_to_toplevel
824 module_list "$@" |
825 while read mode sha1 stage path
826 do
827 name=$(module_name "$path")
828 url=$(git config -f .gitmodules --get submodule."$name".url)
829
830 # Possibly a url relative to parent
831 case "$url" in
832 ./*|../*)
833 url=$(resolve_relative_url "$url") || exit
834 ;;
835 esac
836
837 say "Synchronizing submodule url for '$name'"
838 git config submodule."$name".url "$url"
839
840 if test -e "$path"/.git
841 then
842 (
843 clear_local_git_env
844 cd "$path"
845 remote=$(get_default_remote)
846 git config remote."$remote".url "$url"
847 )
848 fi
849 done
850 }
851
852 # This loop parses the command line arguments to find the
853 # subcommand name to dispatch. Parsing of the subcommand specific
854 # options are primarily done by the subcommand implementations.
855 # Subcommand specific options such as --branch and --cached are
856 # parsed here as well, for backward compatibility.
857
858 while test $# != 0 && test -z "$command"
859 do
860 case "$1" in
861 add | foreach | init | update | status | summary | sync)
862 command=$1
863 ;;
864 -q|--quiet)
865 GIT_QUIET=1
866 ;;
867 -b|--branch)
868 case "$2" in
869 '')
870 usage
871 ;;
872 esac
873 branch="$2"; shift
874 ;;
875 --cached)
876 cached="$1"
877 ;;
878 --)
879 break
880 ;;
881 -*)
882 usage
883 ;;
884 *)
885 break
886 ;;
887 esac
888 shift
889 done
890
891 # No command word defaults to "status"
892 test -n "$command" || command=status
893
894 # "-b branch" is accepted only by "add"
895 if test -n "$branch" && test "$command" != add
896 then
897 usage
898 fi
899
900 # "--cached" is accepted only by "status" and "summary"
901 if test -n "$cached" && test "$command" != status -a "$command" != summary
902 then
903 usage
904 fi
905
906 "cmd_$command" "$@"